<template>
  <div class="form-content">
    <p>Обезличенная базовая цена вычисляется безотносительного того или иного клиента.</p>
    <formula :items="BASE_PRICE_FORMULA" />
    <div>
      <h2 class="section-title">Автоматическая настойка коэффициентов доверия</h2>
      <p>Автоматическая настройка значений коэффициентов доверия позволяет задавать их динамически для каждого класса тарифов в зависимости от объема накопленных по нему данных. Значение α возрастает, а значение β убывает по мере их накопления, пока значение β не сравняется со значением β мин. При этом всегда выполняется равенство α + β = 1.</p>
      <div class="row middle-xs">
        <div class="col-symbol">
          <div class="box symbol-box">
            &beta;
            <sub>мин</sub>
          </div>
        </div>
        <div class="col-input">
          <div class="box-input">
            <ob-input
              class="beta-percent"
              type="money:3"
              :value="bMin"
              @input="updateBetaMin"
              :is-valid="!bMinError"
              is-dirty-force
              :is-convert-money="false"
              validation-message="Укажите значение в интервале от 0 до 1 включительно"
            />
          </div>
        </div>
        <div class="col-tip">
          <div class="box">Наименьшее допустимое значение коэффициента β</div>
        </div>
      </div>
      <div class="row middle-xs">
        <div class="col-symbol">
          <div class="box symbol-box">
            &beta;
            <sub>автор</sub>
          </div>
        </div>
        <div class="col-input">
          <div class="box-input">
            <ob-input
              class="beta-percent"
              type="money:0"
              :value="model.beta_author"
              @input="updateBetaAuthor"
              :is-valid="!bAuthorError"
              is-dirty-force
              :is-convert-money="false"
              validation-message="Укажите значение в интервале от 1 до 9999 включительно"
            />
          </div>
        </div>
        <div class="col-tip">
          <div class="box">
            Количество рейсов, при достижении которых
            β принимает стабильное значение β мин
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

import ObInput from 'common-components/src/obComponents/obInput';
import formula from '../../../../basePricesPage/components/StaticFormula';

const BASE_PRICE_FORMULA = [
  {
    label: 'БЦ',
    index: '',
    tipAbove: '',
    tipBelow: 'ОБЕЗЛИЧЕННАЯ БАЗОВАЯ ЦЕНА',
    tipPositionClass: 'align-right',
    tipSizeClass: 'narrow',
  },
  {
    label: '=',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: 'α',
    index: '',
    tipAbove: 'КОЭФФИЦИЕНТ ДОВЕРИЯ УСРЕДНЕННОМУ ГЕОГРАФИЧЕСКОМУ ТАРИФУ',
    tipBelow: '',
    tipPositionClass: 'align-right',
    tipSizeClass: 'wide',
  },
  {
    label: 'T',
    index: 'геогр.',
    tipAbove: '',
    tipBelow: 'УСРЕДНЕННЫЙ ТАРИФ',
    tipPositionClass: 'align-left',
    tipSizeClass: 'narrow',
  },
  {
    label: '+',
    index: '',
    tipAbove: '',
    tipBelow: '',
    isOperator: true,
  },
  {
    label: 'β',
    index: '',
    tipAbove: 'КОЭФФИЦИЕНТ ДОВЕРИЯ ЭКСПЕРТНОМУ ТАРИФУ',
    tipBelow: '',
    tipPositionClass: 'align-left',
    tipSizeClass: 'mid',
  },
  {
    label: 'T',
    index: 'эксп.',
    tipAbove: '',
    tipBelow: 'ЭКСПЕРТНЫЙ ТАРИФ',
    tipPositionClass: 'align-left',
    tipSizeClass: 'narrow',
  },
];

export default {
  name: 'BasePriceTab',
  components: {
    ObInput,
    formula,
  },
  data() {
    return {
      BASE_PRICE_FORMULA,
    };
  },
  computed: {
    ...mapGetters({
      model: 'base_prices/mathModel',
      modelStatus: 'base_prices/mathModalStatus',
    }),
    bMin() {
      return this.model.beta_min ? this.model.beta_min : 0;
    },
    bMinError() {
      return this.modelStatus && this.modelStatus.bMin;
    },
    bAuthorError() {
      return this.modelStatus && this.modelStatus.bAuthor;
    },
  },
  methods: {
    ...mapActions({
      setMathModelErrorStatus: `base_prices/setMathModelErrorStatus`,
      setMathModelField: 'base_prices/setMathModelField',
    }),
    updateBetaMin(value) {
      //maybe should be better to move validation to store in future
      if (value === '' || value > 1 || value < 0) {
        !this.bMinError &&
          this.setMathModelErrorStatus({ name: 'bMin', value: true });
      } else {
        this.bMinError &&
          this.setMathModelErrorStatus({ name: 'bMin', value: false });
      }

      this.setMathModelField({
        name: 'beta_min',
        value,
      });
    },
    updateBetaAuthor(value) {
      if (value < 1 || value > 9999) {
        !this.bAuthorError &&
          this.setMathModelErrorStatus({ name: 'bAuthor', value: true });
      } else {
        this.bAuthorError &&
          this.setMathModelErrorStatus({ name: 'bAuthor', value: false });
      }

      this.setMathModelField({
        name: 'beta_author',
        value,
      });
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '../../../../../../node_modules/common-components/src/static/css/mixins';

.section-title {
  @include font-mixin(16px, 20px, bold, $cobalt-black, 0.4px);

  padding-top: 20px;
  margin-bottom: 20px;
}
.symbol-box {
  @include font-mixin(32px, 37px, 400, $shale-gray, 0.2px);
  text-align: left;
  sub {
    font-size: 12px;
    text-transform: uppercase;
    margin-left: -8px;
  }
}

.col {
  &-symbol {
    width: 70px;
    margin-right: 20px;
  }
  &-input {
    margin-right: 20px;
  }
  &-tip {
    flex: 1;
    color: #737682;
    font-size: 12px;
  }
}

.box-input {
  width: 110px;
}
.beta-percent {
  text-align: center;
}

::v-deep {
  .section-title {
    margin: 20px 0;
    + p {
      margin: 0 0 20px;
    }
  }
}
</style>